#!/usr/bin/env python3

'''
Code developed by Luca Baronti (lbaronti[at]gmail.com)
'''

import tempfile
import math as mt
import primitive_shapes_generator as psg

def make_mickey_mouse_scene():
	scene=psg.Scene()
	face = psg.Sphere(10000,10)
	scene.add_shape(face)
	eye_left = psg.Sphere(1000,2)
	eye_left.translate((-4,2,9))
	scene.add_shape(eye_left)
	eye_right = psg.Sphere(len(eye_left), eye_left.radius)
	eye_right.translate((4,2,9))
	scene.add_shape(eye_right)
	nose = psg.Sphere(1000,1)
	nose.translate((0,1,10))
	scene.add_shape(nose)
	ear_left=psg.Cylinder(10000,1,7)
	ear_left.rotate(psg.quaternion.fromEuler(mt.pi/2.0,0,0))
	ear_left.translate((-10,10,0))
	scene.add_shape(ear_left)
	ear_right=psg.Cylinder(len(ear_left), ear_left.height, ear_left.radius)
	ear_right.rotate(psg.quaternion.fromEuler(mt.pi/2.0,0,0))
	ear_right.translate((10,10,0))
	scene.add_shape(ear_right)
	mouth = psg.Cylinder(10000,1,6)
	mouth.remove_part(.7)
	mouth.rotate(psg.quaternion.fromEuler(-mt.pi/2.0,mt.pi/12,-mt.pi/2.0))
	mouth.translate((0,-2,8.5))
	scene.add_shape(mouth)
	return scene

def make_snowman_scene():
	scene=psg.Scene()
	face = psg.Sphere(2000,10)
	scene.add_shape(face)
	eye_left = psg.Sphere(500,1.5)
	eye_left.translate((-4,2,9))
	scene.add_shape(eye_left)
	eye_right = psg.Sphere(500,1.5)
	eye_right.translate((4,2,9))
	scene.add_shape(eye_right)
	mouth = psg.Cylinder(1000,1,4)
	mouth.remove_part(.7)
	mouth.rotate(psg.quaternion.fromEuler(-mt.pi/2,0,-mt.pi/2.0))
	mouth.translate((0,-2,9))
	scene.add_shape(mouth)
	nose = psg.Cylinder(500,5,.7)
	nose.rotate(psg.quaternion.fromEuler(mt.pi/2.0,0,0))
	nose.translate((0,1,10))
	scene.add_shape(nose)
	body_1 = psg.Sphere(3000,13)
	body_1.remove_part(.13,psg.quaternion.fromEuler(0,0,mt.pi))
	body_1.translate((0,-15,0))
	scene.add_shape(body_1)
	body_2 = psg.Sphere(3000,16)
	body_2.remove_part(.15,psg.quaternion.fromEuler(0,0,mt.pi))
	body_2.translate((0,-29,0))
	scene.add_shape(body_2)
	hat1 = psg.Cylinder(4000,14,8)
	hat1.translate((-6.5,13,0.0))
	hat1.rotate(psg.quaternion.fromEuler(0,0,mt.pi/6.0))
	scene.add_shape(hat1)
	hat2 = psg.Cylinder(int(len(hat1)/3.0),2,11)
	hat2.translate((-3.7,6,0.0))
	hat2.rotate(psg.quaternion.fromEuler(0,0,mt.pi/6.0))
	scene.add_shape(hat2)
	# right arm
	arm11 = psg.Cylinder(1000,10,1.1)
	arm11.rotate(psg.quaternion.fromEuler(0,0,mt.pi/3.0))
	arm11.translate((-17,-10,0))
	scene.add_shape(arm11)
	joint11 = psg.Sphere(100,arm11.radius+0.1)
	joint11.translate(arm11.getMainAxis()[1])
	scene.add_shape(joint11)
	arm12 = psg.Cylinder(len(arm11),9,arm11.radius)
	arm12.rotate(psg.quaternion.fromEuler(0,0,-mt.pi/4.0))
	arm12_c=joint11.centre
	arm12_c=(arm12_c[0]+3,arm12_c[1]+3,arm12_c[2])
	arm12.translate(arm12_c)
	scene.add_shape(arm12)
	hand1 = psg.Sphere(500,joint11.radius+0.4)
	hand1.translate(arm12.getMainAxis()[1])
	scene.add_shape(hand1)
	finger11 = psg.Cylinder(500,3,.3)
	finger11_c=(hand1.centre[0]+2,hand1.centre[1]+1,hand1.centre[2])
	finger11.rotate(psg.quaternion.fromEuler(0,0,-mt.pi/3.0))
	finger11.translate(finger11_c)
	scene.add_shape(finger11)
	finger12 = psg.Cylinder(len(finger11),finger11.height,finger11.radius)
	finger12_c=(hand1.centre[0]+1,hand1.centre[1]+2,hand1.centre[2]-1)
	finger12.rotate(psg.quaternion.fromEuler(-mt.pi/12.0,0,-mt.pi/5.0))
	finger12.translate(finger12_c)
	scene.add_shape(finger12)
	finger13 = psg.Cylinder(len(finger11),finger11.height,finger11.radius)
	finger13_c=(hand1.centre[0]+1,hand1.centre[1]+2,hand1.centre[2]+1)
	finger13.rotate(psg.quaternion.fromEuler(mt.pi/12.0,0,-mt.pi/5.0))
	finger13.translate(finger13_c)
	scene.add_shape(finger13)
	# left arm
	arm21 = psg.Cylinder(len(arm11),arm11.height,arm11.radius)
	arm21.rotate(psg.quaternion.fromEuler(mt.pi/12.0,0,-mt.pi/3.0))
	arm21.translate((17,-10,0))
	scene.add_shape(arm21)
	joint21 = psg.Sphere(len(joint11),arm21.radius+0.1)
	joint21.translate(arm21.getMainAxis()[1])
	scene.add_shape(joint21)
	arm22 = psg.Cylinder(len(arm12),arm12.height,arm12.radius)
	arm22.rotate(psg.quaternion.fromEuler(mt.pi/8.0,0,-mt.pi/8.0))
	arm22_c=joint21.centre
	arm22_c=(arm22_c[0]+2,arm22_c[1]+4,arm22_c[2]+2)
	arm22.translate(arm22_c)
	scene.add_shape(arm22)
	hand2 = psg.Sphere(len(hand1),hand1.radius)
	hand2.translate(arm22.getMainAxis()[1])
	scene.add_shape(hand2)
	finger21 = psg.Cylinder(len(finger11), finger11.height, finger11.radius)
	finger21_c=(hand2.centre[0]+2,hand2.centre[1]+2,hand2.centre[2]+1)
	finger21.rotate(psg.quaternion.fromEuler(mt.pi/8.0,0,-mt.pi/4.0))
	finger21.translate(finger21_c)
	scene.add_shape(finger21)
	finger22 = psg.Cylinder(len(finger11), finger11.height, finger11.radius)
	finger22_c=(hand2.centre[0],hand2.centre[1]+3,hand2.centre[2])
	finger22.translate(finger22_c)
	scene.add_shape(finger22)
	finger23 = psg.Cylinder(len(finger11), finger11.height, finger11.radius)
	finger23_c=(hand2.centre[0]-2,hand2.centre[1]+1,hand2.centre[2])
	finger23.rotate(psg.quaternion.fromEuler(mt.pi/8.0,0,mt.pi/4.0))
	finger23.translate(finger23_c)
	scene.add_shape(finger23)
	return scene

def make_surface():
	n_points_sphere=10000
	grid_size = (5,5)
	scene = psg.Scene()
	for i in range(grid_size[0]):
		for j in range(grid_size[1]):
			s = psg.Sphere(n_points_sphere,1)
			s.translate((i,j,0))
			scene.add_shape(s)
	b = psg.Box(0,grid_size[0]+4,grid_size[1]+4,2)
	b.translate((grid_size[0]*.5,grid_size[1]*.5,-0.25))
	scene.add_shape(b)
	scene.generateAllPointsAndNormal(only_surface=True)
	return scene

if __name__ == '__main__':
	make_mickey_mouse_scene().save(tempfile.gettempdir()+"/mikey_mouse.pcd",only_surface=True)
	print("Mickey Mouse saved on",tempfile.gettempdir()+"/mikey_mouse.pcd")
	make_snowman_scene().save(tempfile.gettempdir()+"/snowman.pcd",only_surface=True)
	print("Snowman saved on",tempfile.gettempdir()+"/snowman.pcd")
	make_surface().save(tempfile.gettempdir()+"/surface.pcd")
	print("Surface saved on",tempfile.gettempdir()+"/surface.pcd")


